//========================================================
// BiggieSmalls Mutator by Mr.Loathsome.  RC4 - 7/23/2011
//========================================================
class BS expands Mutator config(BS);

var bool bInit;
var() config float MinSize;
var() config float MaxSize;
var() config float MinMSize;
var() config float MaxMSize;
var() config float ReSizeVal;


function PostBeginPlay()
{
	if (bInit) return; else bInit = True;
	log("BiggieSmalls: Init");
	Level.Game.RegisterDamageMutator( Self );
	Super.PostBeginPlay();
}

function ModifyPlayer(Pawn Other)
{
	Super.ModifyPlayer(Other);
	Other.DrawScale = Other.default.DrawScale;
	Other.SetCollisionSize((Other.default.CollisionRadius), (Other.default.CollisionHeight));
	Other.Mass = Other.default.Mass;
	if (Other.Shadow != None)
		{ Other.Shadow.DrawScale = Other.Shadow.default.DrawScale; }
}

function bool CheckCollision(Actor A, float DSM, vector newLoc)  // Credit to Feralidragon for help with this function
{
	local bool isColliding;
	local float CRadius, CHeight;

	CRadius = A.CollisionRadius;
	CHeight = A.CollisionHeight;
	A.SetCollisionSize(A.CollisionRadius * DSM, A.CollisionHeight * DSM);
	isColliding = !A.SetLocation(newLoc);
	A.SetCollisionSize(CRadius, CHeight);
	return isColliding;
}

function MutatorTakeDamage( out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, 
						out Vector Momentum, name DamageType)
{
	local float F, MinS, MaxS;
	local Vector V;

	if (!((Victim.bIsPlayer) && (InstigatedBy != None) && (InstigatedBy.bIsPlayer) && (Level.Game.bTeamGame) && (Victim.PlayerReplicationInfo.Team == InstigatedBy.PlayerReplicationInfo.Team)))
	{
		if (ScriptedPawn(Victim) != None) { MinS = MinMSize; MaxS = MaxMSize; } else { MinS = MinSize; MaxS = MaxSize; }
		if (((Victim.Health - ActualDamage) > 0) && (MinS != MaxS) && (Victim.DrawScale > (Victim.default.DrawScale * MinS)))
		{		
			F = 1.0 - ReSizeVal;
			V = Victim.Location;
			Victim.DrawScale = Victim.DrawScale * F;
			Victim.Mass = Victim.Mass * F;
			if (Victim.Shadow != None)
				{ Victim.Shadow.DrawScale = Victim.Shadow.DrawScale * F; }
			Victim.SetCollisionSize((Victim.CollisionRadius * F), (Victim.CollisionHeight * F));
		}
	}
	if (InstigatedBy != None)
	{
		if (ScriptedPawn(InstigatedBy) != None) { MinS = MinMSize; MaxS = MaxMSize; } else { MinS = MinSize; MaxS = MaxSize; }
		if ((Victim != InstigatedBy) && (MinS != MaxS) && (InstigatedBy.DrawScale < (InstigatedBy.default.DrawScale * MaxS)))
		{
			F = 1.0 + ReSizeVal;
			V = InstigatedBy.Location;
			if (!CheckCollision(InstigatedBy, F, V))
			{
				InstigatedBy.DrawScale = InstigatedBy.DrawScale * F;
				InstigatedBy.Mass = InstigatedBy.Mass * F;
				if (InstigatedBy.Shadow != None)
					{ InstigatedBy.Shadow.DrawScale = InstigatedBy.Shadow.DrawScale * F; }
				InstigatedBy.SetCollisionSize((InstigatedBy.CollisionRadius * F), (InstigatedBy.CollisionHeight * F));
			}
		}
	}
	Super.MutatorTakeDamage( ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType );	
}

defaultproperties
{
     MinSize=0.2500
     MaxSize=1.2500
     MinMSize=0.2500
     MaxMSize=1.7500
     ReSizeVal=0.0500
}
